from ..object_compare_tracking import ObjectComparisonTracking

import enstools.feature.identification.african_easterly_waves.configuration as cfg
from enstools.feature.util.graph import GraphStructure


# TODO need template for non-comparison trackings?
class AEWTracking(ObjectComparisonTracking):

    def __init__(self, **kwargs):
        self.config = cfg
        super().__init__() # TODO this in template? need empty graph to be generated
        pass

    def correspond(self, time1, obj1, time2, obj2):
        # returns True if objects are same wave

        # access the properties set earlier
        prop1 = obj1.properties
        prop2 = obj2.properties

        time_diff = time2 - time1
        time_diff_h = time_diff.seconds // 3600

        # take bounding box and propagate it with AEW speed -> search for overlap
        # lats dont change, propagate min_lon with max speed, max_lon with min speed so search range increases

        min_lon_predicted = prop1.bb.min.lon + self.config.speed_deg_per_h[1] * time_diff_h
        max_lon_predicted = prop1.bb.max.lon + self.config.speed_deg_per_h[0] * time_diff_h
        min_lat_predicted = prop1.bb.min.lat
        max_lat_predicted = prop1.bb.max.lat

        if ((min_lon_predicted <= prop2.bb.max.lon and max_lon_predicted >= prop2.bb.min.lon)
                and (min_lat_predicted <= prop2.bb.max.lat and max_lat_predicted >= prop2.bb.min.lat)):
            # print("overlap")
            return True

        # print("no overlap")
        return False

    def postprocess(self, obj_desc):
        print("postprocess @ aew")
        return
